/*
 * Licensed to the Apache Software Foundation (ASF) under one
 * or more contributor license agreements.  See the NOTICE file
 * distributed with this work for additional information
 * regarding copyright ownership.  The ASF licenses this file
 * to you under the Apache License, Version 2.0 (the
 * "License"); you may not use this file except in compliance
 * with the License.  You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing,
 * software distributed under the License is distributed on an
 * "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
 * KIND, either express or implied.  See the License for the
 * specific language governing permissions and limitations
 * under the License.
 */

const simulateKeyPress = function(type, code) {
    const event = document.createEvent("Event");
    event.initEvent(type, true, true);
    event.keyCode = code;
    const scene = document.getElementsByClassName("roku-scene")[0];

    scene.dispatchEvent(event);
};
const KEYS = {
    OK: 13,
    BACK: 8,
    RIGHT: 39,
    LEFT: 37,
    UP: 38,
    DOWN: 40
};

const keyPress = function simulate(_key) {
    const key = KEYS[_key] || _key;
    simulateKeyPress("keydown", key);
    setTimeout(function() {
        simulateKeyPress("keyup", key);
    }, 200);
    return new Promise(function(resolve) {
        setTimeout(resolve, 201);
    });
};

document.aphrodite_secret = "w8J8QBAp9J";
if (!window.speechSynthesis) {
    window.speechSynthesis = {};
}
document.body.style.backgroundColor = "transparent !important";
const eventHandlers = {
    KEYCODE_MEDIA_FAST_FORWARD: function() {
        ExoPlayer.showController();
        ExoPlayer.seekBy(10 * 1000);
    },
    KEYCODE_MEDIA_PLAY_PAUSE: function() {
        ExoPlayer.playPause();
    },
    KEYCODE_MEDIA_REWIND: function() {
        ExoPlayer.showController();
        ExoPlayer.seekBy(-10 * 1000);
    },
    KEYCODE_BACK: function() {
        ExoPlayer.close();
    }
};
var app = {
    // Application Constructor
    initialize: function() {
        document.addEventListener("deviceready", this.onDeviceReady.bind(this), false);
    },

    // deviceready Event Handler
    //
    // Bind any cordova events here. Common events are:
    // 'pause', 'resume', etc.

    onDeviceReady: function() {
        function mainloop() {
            // call the plugin every (say) one second to keep your app awake
            window.plugins.insomnia.keepAwake();
        }
        window.keepAwake = function() {
            clearInterval(window.keepAwakeLoop)
            window.keepAwakeLoop = setInterval(mainloop, 5000);
        };
        window.allowSleepAgain = function() {
            clearInterval(window.keepAwakeLoop);
            window.plugins.insomnia.allowSleepAgain()
        }
        
        console.log(device);
        function onBackKeyDown(e) {
            e.preventDefault();
            keyPress("BACK");
            // Handle the back button
        }
        document.addEventListener("backbutton", onBackKeyDown, false);
        var exited = false;
        var playWhenReady;
        document.addEventListener(
            "pause",
            function() {
                if (!exited) {
                    ExoPlayer.getState(function(state) {
                        playWhenReady = state.playWhenReady;
                        if (playWhenReady) {
                            window.ExoPlayer.pause();
                            window.ExoPlayer.abandonAudioFocus();
                        }
                    });
                }
            },
            false
        );

        document.addEventListener(
            "resume",
            function() {
                if (playWhenReady) {
                    window.ExoPlayer.requestAudioFocus();
                    window.ExoPlayer.play();
                }
            },
            false
        );

        this.receivedEvent("deviceready");
        cordova.plugins.idfa.getInfo().then(function(r) {
            window.limitedAdTracking = r.limitAdTracking;
        });
        window.plugins.screensize.get(
            function(result) {
                console.log(result);
            },
            function() {}
        );

        function successCallback(result) {
            console.log(result);
        }
    },

    // Update DOM on a Received Event
    receivedEvent: function(id) {}
};

app.initialize();
